"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var t = _interopRequireWildcard(require("@babel/types"));

var _core = require("@dubstep/core");

var _shared = require("./shared.js");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

/*
Copyright (c) 2018-2019 Uber Technologies, Inc.

This source code is licensed under the MIT license found in the
LICENSE file in the root directory of this source tree.
*/
function isStyledElement(path) {
  return path.node.arguments && path.node.arguments.length && path.node.arguments[0].type === 'StringLiteral';
}

function isStyledComponent(path) {
  return path.node.arguments && path.node.arguments.length && path.node.arguments[0].type === 'Identifier';
}

async function styledV7TypeArguments(options) {
  await (0, _core.withJsFiles)(`${options.dir}/**/*.js`, async p => {
    if ((0, _shared.containsFlowComment)(p)) {
      const styledLocalImportName = (0, _shared.getStyledLocalImportName)(p);

      if (styledLocalImportName) {
        p.traverse({
          CallExpression(path) {
            if (path.node.callee.name === styledLocalImportName && !path.node.typeArguments) {
              if (path.node.arguments.length === 1) {
                path.node.arguments.push(t.objectExpression([]));
              }

              if (isStyledElement(path)) {
                if (!t.isObjectExpression(path.node.arguments[1])) {
                  path.node.callee.typeAnnotation = t.typeParameterInstantiation([t.anyTypeAnnotation()]);
                }
              } else if (isStyledComponent(path)) {
                const base = path.node.arguments[0];

                if (!t.isObjectExpression(path.node.arguments[1])) {
                  path.node.callee.typeAnnotation = t.typeParameterInstantiation([t.typeofTypeAnnotation(t.genericTypeAnnotation(base)), t.anyTypeAnnotation()]);
                } else {
                  path.node.callee.typeAnnotation = t.typeParameterInstantiation([t.typeofTypeAnnotation(t.genericTypeAnnotation(base))]);
                }
              }
            }
          }

        });
      }
    }
  });
}

var _default = styledV7TypeArguments;
exports.default = _default;